#define WIN32_LEAN_AND_MEAN

#include <windows.h>
// -- GDI+ requires these headers --
#include <initguid.h>
#include <objbase.h>
#include <gdiplus.h>
	using namespace Gdiplus;
	#pragma comment(lib, "gdiplus")
// ---------------------------------
#include "resource.h"

#if defined(DEBUG)
#include <stdio.h>
#endif

HINSTANCE hInst;

void OnPaint(HDC hdc)
{
#if defined(DEBUG)
	UINT32 startTick  = GetTickCount();
	UINT32 finishTick = 0;
#endif
	Graphics G(hdc);
	Pen P(Color(255,0,0,255),5);
	G.DrawEllipse(&P,10,10,300,200);
#if defined(DEBUG)
	finishTick = GetTickCount();
	printf(TEXT("drawing taken %d ms.\n"),finishTick - startTick);
#endif
}

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

    switch(uMsg)
    {
		case WM_INITDIALOG:
			return TRUE;

        case WM_CLOSE:
			EndDialog(hwndDlg, 0);
			return TRUE;

		case WM_PAINT:
			hdc=BeginPaint(hwndDlg, &ps);
			OnPaint(hdc);
			EndPaint(hwndDlg, &ps);
			return 0;

		case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case IDC_BTN_QUIT:
                    EndDialog(hwndDlg, 0);
                    return TRUE;
            }
    }

    return FALSE;
}


int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
    hInst    = hInstance;
    int retI = 0;

     ULONG_PTR gpToken;

     GdiplusStartupInput gpsi;

     if (GdiplusStartup(&gpToken,&gpsi,NULL) != Ok)
     {
          MessageBox(NULL,TEXT("Can not initialize GDI+ library."),TEXT("ERROR"),MB_OK);
          return 0;
     }

    retI = DialogBox(hInstance, MAKEINTRESOURCE(DLG_MAIN), NULL, DialogProc);

	GdiplusShutdown(gpToken);

    return retI;
}
